function AutoSelfCast_Initialize()
    local info = ChatTypeInfo["SYSTEM"];
    DEFAULT_CHAT_FRAME:AddMessage("AutoSelfCast enabled.", info.r, info.g, info.b, info.id);

    local oldActionButtonUp = ActionButtonUp;

    ActionButtonUp = function(id, onSelf)
        oldActionButtonUp(id, onSelf);

        if not onSelf and not SpellCanTargetUnit("target") and SpellCanTargetUnit("player") then
            SpellTargetUnit("player");
        end
    end

    local oldActionButtonOnEvent = ActionButton_OnEvent;

    ActionButton_OnEvent = function(event)
        oldActionButtonOnEvent(event);

        if IsCurrentAction(ActionButton_GetPagedID(this)) and event == "ACTIONBAR_UPDATE_STATE" and (arg1 == "LeftButton" or arg1 == "RightButton") then
            if not SpellCanTargetUnit("target") and SpellCanTargetUnit("player") and SpellIsTargeting() then
                -- prevents a stupid error
                if this.moyashiFudge == 1 then
                    SpellTargetUnit("player");
                    this.moyashiFudge = 0;
                else
                    this.moyashiFudge = 1;
                end
            end
        end
    end
end